import React, { Component } from 'react';
import { extends as _extends, inherits as _inherits, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, objectSpread2 as _objectSpread2, createClass as _createClass } from '../_virtual/_rollupPluginBabelHelpers.js';
import { connect, Provider } from 'react-redux';
import './config.js';
import { store, persistor } from './store.js';
import { PersistGate as react_1 } from '../node_modules/redux-persist/lib/integration/react.js';
import { Layout, Tabs, Card } from 'antd';
import Tree from './Tree/index.js';
import FormView from './views/FormView.js';
import SchemaView from './views/SchemaView.js';
import UiSchemaView from './views/UiSchemaView.js';
import FormDataView from './views/FormDataView.js';
import NodeEditor from './Editor/index.js';
import Toolbar from './Toolbar.js';
import Settings from './Settings.js';
import openFormList from './remote/openFormList.js';

var Header = Layout.Header,
    Sider = Layout.Sider,
    Content = Layout.Content;
var TabPane = Tabs.TabPane;
var dispatch = store.dispatch;

var App =
/*#__PURE__*/
function (_Component) {
  _inherits(App, _Component);

  function App() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, App);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(App)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      collapsed: false,
      data: _this.props.data,
      modal: null
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      _this.setState({
        collapsed: !_this.state.collapsed
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setStore", function (_ref) {
      var schema = _ref.schema,
          uiSchema = _ref.uiSchema,
          formData = _ref.formData;
      dispatch({
        type: 'TREE_SET_TREE',
        payload: {
          schema: schema,
          uiSchema: uiSchema
        }
      });
      dispatch({
        type: 'FORM_DATA_SET',
        payload: formData
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleSave", function (config) {
      var _this$state = _this.state,
          formId = _this$state.formId,
          formName = _this$state.formName;

      if (_this.state.create) {
        if (_this.props.onCreate) {
          _this.props.onCreate(_objectSpread2({
            name: config.schema.title
          }, config));
        }
      } else {
        if (_this.props.onSave) {
          _this.props.onSave(_objectSpread2({
            id: formId,
            name: formName
          }, config));
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelect", function (config) {
      var _ref2 = config || {},
          id = _ref2.id,
          name = _ref2.name,
          _ref2$schema = _ref2.schema,
          schema = _ref2$schema === void 0 ? {
        title: 'ofm'
      } : _ref2$schema,
          _ref2$uiSchema = _ref2.uiSchema,
          uiSchema = _ref2$uiSchema === void 0 ? {} : _ref2$uiSchema,
          _ref2$formData = _ref2.formData,
          formData = _ref2$formData === void 0 ? {} : _ref2$formData;

      _this.setStore({
        schema: schema,
        uiSchema: uiSchema,
        formData: formData
      });

      _this.setState({
        create: !id,
        formId: id,
        formName: name
      });
    });

    _defineProperty(_assertThisInitialized(_this), "openModal", function () {
      var m = openFormList(_this.state.data, _this.handleSelect);

      _this.setState({
        modal: m
      });
    });

    return _this;
  }

  _createClass(App, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.data !== this.props.data) {
        if (nextProps.data !== null && nextProps.data !== undefined && this.state.modal === null) {
          var m = openFormList(this.state.data, this.handleSelect);
          this.setState({
            modal: m,
            data: nextProps.data
          });
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.data !== this.props.data) {
        this.setState({
          data: this.props.data
        });

        if (this.props.data) ;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var settings = this.props.settings;
      return React.createElement(Layout, {
        style: {
          transform: 'rotate(0)'
        }
      }, React.createElement(Sider, {
        trigger: null,
        collapsible: true,
        collapsed: this.state.collapsed,
        width: settings.leftSiderWidth,
        style: {
          background: '#fff',
          padding: 0,
          overflow: 'auto',
          boxShadow: '0 2px 3px 0 rgba(0, 0, 0, 0.2), 0 2px 3px 0 rgba(0, 0, 0, 0.2)',
          height: '100vh',
          position: 'fixed',
          left: 0
        }
      }, React.createElement(Tabs, {
        defaultActiveKey: "0",
        size: "small"
      }, React.createElement(TabPane, {
        tab: "Editor",
        style: {
          padding: '8px'
        },
        key: "0"
      }, React.createElement(Tree, null)), React.createElement(TabPane, {
        tab: "Settings",
        style: {
          padding: '8px'
        },
        key: "1"
      }, React.createElement(Settings, null)))), React.createElement(Layout, {
        style: {
          marginLeft: settings.leftSiderWidth
        }
      }, React.createElement(Header, {
        style: {
          background: '#fff',
          padding: 0
        }
      }, React.createElement(Toolbar, {
        onOpen: function onOpen() {
          return _this2.openModal();
        },
        onSave: this.handleSave
      })), React.createElement(Content, {
        style: {
          minHeight: 280,
          padding: '12px 8px',
          display: 'flex',
          flexWrap: 'wrap'
        }
      }, React.createElement(Card, {
        bordered: false,
        style: {
          width: settings.formWidth,
          margin: '12px 8px',
          display: 'inline-block',
          verticalAlign: 'top'
        }
      }, React.createElement(FormView, null)), (settings.subViews || []).map(function (a) {
        var style = {
          margin: '12px 8px',
          width: 400,
          display: 'inline-block',
          verticalAlign: 'top',
          maxHeight: '800px',
          overflowY: 'scroll'
        };

        switch (a) {
          case 'schema':
            return React.createElement(Card, {
              key: "schema",
              title: "Schema",
              style: style
            }, React.createElement(SchemaView, null));

          case 'uiSchema':
            return React.createElement(Card, {
              key: "uiSchema",
              title: "Ui Schema",
              style: style
            }, React.createElement(UiSchemaView, null));

          case 'formData':
            return React.createElement(Card, {
              key: "formData",
              title: "Form Data",
              style: style
            }, React.createElement(FormDataView, null));

          default:
            return React.createElement("div", {
              key: "null"
            });
        }
      }))), React.createElement(Sider, {
        width: this.props.activeNodeKey ? settings.rightSiderWidth : 0,
        style: {
          overflow: 'auto',
          background: '#fff',
          boxShadow: '0 2px 3px 0 rgba(0, 0, 0, 0.2), 0 2px 3px 0 rgba(0, 0, 0, 0.2)',
          // position: 'fixed',
          height: '100vh' // right: 0,

        }
      }, React.createElement(NodeEditor, null)));
    }
  }]);

  return App;
}(Component);

var AppContainer = connect(function (_ref3) {
  var activeNodeKey = _ref3.activeNodeKey,
      settings = _ref3.settings;
  return {
    activeNodeKey: activeNodeKey,
    settings: settings
  };
})(App);
var App$1 = (function (_ref4) {
  var props = _extends({}, _ref4);

  return React.createElement(Provider, {
    store: store
  }, React.createElement(react_1, {
    loading: null,
    persistor: persistor
  }, React.createElement(AppContainer, props)));
});

export default App$1;
