import React from 'react';
import { inherits as _inherits, createClass as _createClass, slicedToArray as _slicedToArray, defineProperty as _defineProperty, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, assertThisInitialized as _assertThisInitialized, toConsumableArray as _toConsumableArray, objectWithoutProperties as _objectWithoutProperties, extends as _extends, objectSpread2 as _objectSpread2 } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { Input, Select, Menu, List, Button, Icon, Row, Col, Dropdown, Slider, Switch, InputNumber } from 'antd';
import lodash from '../../node_modules/lodash/lodash.js';

var TextArea = Input.TextArea;
var Option = Select.Option;
function FormItemTemplate(_ref2) {
  var title = _ref2.title,
      children = _ref2.children,
      remove = _ref2.remove;
  return React.createElement(List.Item, {
    actions: remove ? [React.createElement(Button, {
      onClick: remove,
      size: "small",
      type: "danger",
      shape: "circle",
      icon: "close"
    })] : null
  }, React.createElement(List.Item.Meta, {
    title: title,
    description: children
  }));
}

var TimeThrottle =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TimeThrottle, _React$Component);

  function TimeThrottle(props) {
    var _this;

    _classCallCheck(this, TimeThrottle);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TimeThrottle).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "throttle", 1000);

    _defineProperty(_assertThisInitialized(_this), "editing", React.createElement(Icon, {
      type: "edit"
    }));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (value) {
      if (_this.state.timer) {
        clearTimeout(_this.state.timer);
      }

      _this.setState({
        value: value,
        timer: setTimeout(function () {
          _this.setState({
            timer: null
          });

          _this.onSubmitValue(_this.state.value);
        }, _this.throttle)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function () {
      if (_this.state.timer) {
        clearTimeout(_this.state.timer);
      }

      _this.setState({
        timer: null
      });

      _this.onSubmitValue(_this.state.value);
    });

    _defineProperty(_assertThisInitialized(_this), "onRemove", function () {
      if (_this.state.timer) {
        clearTimeout(_this.state.timer);
      }

      _this.setState({
        timer: null
      });

      _this.onSubmitValue(undefined);
    });

    _this.state = {
      timer: null,
      value: props.value
    };
    return _this;
  }

  _createClass(TimeThrottle, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.state.timer) {
        clearTimeout(this.state.timer);
        this.setState({
          timer: null
        });
        this.onSubmitValue(this.state.value);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.state.value) {
        if (this.state.timer) {
          clearTimeout(this.state.timer); // this.props.onChange(this.state.value);
        }

        this.setState({
          value: nextProps.value,
          timer: null
        });
      }
    }
  }, {
    key: "onSubmitValue",
    value: function onSubmitValue(value) {
      this.props.onChange(value);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return TimeThrottle;
}(React.Component);

var TimeThrottleInput =
/*#__PURE__*/
function (_TimeThrottle) {
  _inherits(TimeThrottleInput, _TimeThrottle);

  function TimeThrottleInput() {
    _classCallCheck(this, TimeThrottleInput);

    return _possibleConstructorReturn(this, _getPrototypeOf(TimeThrottleInput).apply(this, arguments));
  }

  _createClass(TimeThrottleInput, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          title = _this$props.title,
          rest = _objectWithoutProperties(_this$props, ["title"]);

      return React.createElement(FormItemTemplate, {
        title: React.createElement("span", null, title, this.state.timer ? this.editing : null),
        remove: this.onRemove
      }, React.createElement(Input, _extends({}, rest, {
        value: this.state.value,
        onChange: function onChange(e) {
          return _this2.onChange(e.target.value);
        },
        onBlur: this.onBlur
      })));
    }
  }]);

  return TimeThrottleInput;
}(TimeThrottle);

var TimeThrottleTextArea =
/*#__PURE__*/
function (_TimeThrottle2) {
  _inherits(TimeThrottleTextArea, _TimeThrottle2);

  function TimeThrottleTextArea() {
    _classCallCheck(this, TimeThrottleTextArea);

    return _possibleConstructorReturn(this, _getPrototypeOf(TimeThrottleTextArea).apply(this, arguments));
  }

  _createClass(TimeThrottleTextArea, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          title = _this$props2.title,
          rest = _objectWithoutProperties(_this$props2, ["title"]);

      var titleElement = React.createElement("span", null, title, this.state.timer ? this.editing : null);
      return React.createElement(FormItemTemplate, {
        title: titleElement,
        remove: this.onRemove
      }, React.createElement(TextArea, _extends({}, rest, {
        value: this.state.value,
        onChange: function onChange(e) {
          return _this3.onChange(e.target.value);
        },
        onBlur: this.onBlur
      })));
    }
  }]);

  return TimeThrottleTextArea;
}(TimeThrottle);

var TimeThrottleRange =
/*#__PURE__*/
function (_TimeThrottle3) {
  _inherits(TimeThrottleRange, _TimeThrottle3);

  function TimeThrottleRange() {
    _classCallCheck(this, TimeThrottleRange);

    return _possibleConstructorReturn(this, _getPrototypeOf(TimeThrottleRange).apply(this, arguments));
  }

  _createClass(TimeThrottleRange, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value[0] !== this.state.value[0] || nextProps.value[1] !== this.state.value[1]) {
        if (this.state.timer) {
          clearTimeout(this.state.timer); // this.props.onChange(this.state.value);
        }

        this.setState({
          value: nextProps.value,
          timer: null
        });
      }
    }
  }, {
    key: "onSubmitValue",
    value: function onSubmitValue(value) {
      if (!value) {
        this.props.onChange(value);
      }

      var _value = _slicedToArray(value, 2),
          min = _value[0],
          max = _value[1];

      if (typeof min === 'string') {
        if (min) {
          min = this.props.value[0];
        } else {
          min = undefined;
        }
      }

      if (typeof max === 'string') {
        if (max) {
          max = this.props.value[1];
        } else {
          max = undefined;
        }
      }

      this.props.onChange([min, max]);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          _this$state$value = _slicedToArray(_this$state.value, 2),
          min = _this$state$value[0],
          max = _this$state$value[1],
          timer = _this$state.timer;

      var title = this.props.title;
      var titleElement = React.createElement("span", null, title, timer ? this.editing : null);
      return React.createElement(FormItemTemplate, {
        title: titleElement,
        remove: this.onRemove
      }, React.createElement(InputNumber, {
        onChange: function onChange(n) {
          _this4.onChange([typeof n === 'string' && !n ? undefined : n, max]);
        },
        value: min === 0 && max === undefined ? '' : min,
        style: {
          width: 100,
          textAlign: 'center'
        },
        placeholder: "Minimum"
      }), React.createElement(Input, {
        style: {
          width: 30,
          borderLeft: 0,
          pointerEvents: 'none',
          backgroundColor: '#fff'
        },
        placeholder: "~",
        disabled: true
      }), React.createElement(InputNumber, {
        onChange: function onChange(n) {
          _this4.onChange([min, typeof n === 'string' && !n ? undefined : n]);
        },
        value: max,
        style: {
          width: 100,
          textAlign: 'center',
          borderLeft: 0
        },
        placeholder: "Maximum"
      }));
    }
  }]);

  return TimeThrottleRange;
}(TimeThrottle);

var widgetMap = {
  boolean: {
    checkbox: 'CheckboxWidget',
    radio: 'RadioWidget',
    select: 'SelectWidget',
    hidden: 'HiddenWidget'
  },
  string: {
    text: 'TextWidget',
    password: 'PasswordWidget',
    // email: "EmailWidget",
    // hostname: "TextWidget",
    // ipv4: "TextWidget",
    // ipv6: "TextWidget",
    uri: 'URLWidget',
    'data-url': 'FileWidget',
    radio: 'RadioWidget',
    select: 'SelectWidget',
    textarea: 'TextareaWidget',
    hidden: 'HiddenWidget',
    date: 'DateWidget',
    datetime: 'DateTimeWidget',
    // "date-time": "DateTimeWidget",
    'alt-date': 'AltDateWidget',
    'alt-datetime': 'AltDateTimeWidget',
    color: 'ColorWidget',
    file: 'FileWidget'
  },
  number: {
    text: 'TextWidget',
    select: 'SelectWidget',
    updown: 'UpDownWidget',
    range: 'RangeWidget',
    radio: 'RadioWidget',
    hidden: 'HiddenWidget'
  },
  integer: {
    text: 'TextWidget',
    select: 'SelectWidget',
    updown: 'UpDownWidget',
    range: 'RangeWidget',
    radio: 'RadioWidget',
    hidden: 'HiddenWidget'
  },
  array: {
    select: 'SelectWidget',
    checkboxes: 'CheckboxesWidget',
    files: 'FileWidget'
  }
};
var widgets = lodash(widgetMap).toPairs().flatMap(function (_ref3) {
  var _ref4 = _slicedToArray(_ref3, 2),
      type = _ref4[0],
      widgets = _ref4[1];

  return lodash(widgets).toPairs().map(function (_ref5) {
    var _ref6 = _slicedToArray(_ref5, 1),
        widget = _ref6[0];

    return [widget, type];
  }).value();
}).groupBy('0').toPairs().map(function (_ref7) {
  var _ref8 = _slicedToArray(_ref7, 2),
      widget = _ref8[0],
      types = _ref8[1];

  return [widget, types.map(function (a) {
    return a[1];
  })];
}).map(function (_ref9) {
  var _ref10 = _slicedToArray(_ref9, 2),
      widget = _ref10[0],
      types = _ref10[1];

  return [types.length > 1 ? function (_ref11) {
    var type = _ref11.type;
    return types.includes(type);
  } : function (t) {
    return function (_ref12) {
      var type = _ref12.type;
      return type === t;
    };
  }(types[0]), widget];
}).map(function (_ref13) {
  var _ref14 = _slicedToArray(_ref13, 2),
      filter = _ref14[0],
      widget = _ref14[1];

  switch (widget) {
    case 'select':
    case 'radio':
      return [function (schema, uiSchema) {
        return schema.enum && filter(schema, uiSchema);
      }, widget];

    default:
      return [filter, widget];
  }
}).value();

function type(_ref15) {
  var schema = _ref15.node.schema,
      update = _ref15.updateSchema;
  var key = 'type';
  var title = 'Type';
  var availableTypes = ['string', 'number', 'integer', 'boolean'];
  if (!availableTypes.includes(schema.type)) return [];
  var value = (schema || {})[key];
  return [null, React.createElement(FormItemTemplate, {
    key: key,
    title: title,
    remove: function remove() {
      return update(_defineProperty({}, key, undefined));
    }
  }, React.createElement(Select, {
    onChange: function onChange(value) {
      return update(_defineProperty({}, key, value));
    },
    value: value,
    style: {
      width: '100%'
    }
  }, availableTypes.map(function (key) {
    return React.createElement(Option, {
      key: key
    }, key);
  })))];
}

function title(_ref16) {
  var schema = _ref16.node.schema,
      update = _ref16.updateSchema;
  var key = 'title';
  var title = 'Title';
  var value = (schema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(TimeThrottleInput, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value || undefined));
      }
    })];
  }
}

function description(_ref17) {
  var schema = _ref17.node.schema,
      update = _ref17.updateSchema;
  var key = 'description';
  var title = 'Description';
  var value = (schema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(TimeThrottleTextArea, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value || undefined));
      },
      autosize: true
    })];
  }
}

var ClassNamesEditor =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(ClassNamesEditor, _React$Component2);

  function ClassNamesEditor(props) {
    var _this5;

    _classCallCheck(this, ClassNamesEditor);

    _this5 = _possibleConstructorReturn(this, _getPrototypeOf(ClassNamesEditor).call(this, props));

    _defineProperty(_assertThisInitialized(_this5), "colSizes", ['sm', 'md', 'lg', 'xl']);

    _defineProperty(_assertThisInitialized(_this5), "style", {
      width: '100%'
    });

    _defineProperty(_assertThisInitialized(_this5), "onSliderChange", function (value) {
      var _this5$state = _this5.state,
          classNames = _this5$state.value,
          col = _this5$state.col;
      var found = false;
      var newClassNames = classNames.map(function (a) {
        var _a$split = a.split('-'),
            _a$split2 = _slicedToArray(_a$split, 3),
            perfix = _a$split2[0],
            b = _a$split2[1],
            v = _a$split2[2];

        if (perfix === 'col' && b === col && Number.isInteger(+v)) {
          found = true;
          return value ? "col-".concat(b, "-").concat(value) : '';
        }

        return a;
      }).filter(function (a) {
        return a;
      });

      if (!found && value) {
        newClassNames.push("col-".concat(col, "-").concat(value));
      }

      _this5.props.onChange(newClassNames.join(' '));
    });

    var _value2 = _toConsumableArray(new Set(_this5.props.value.split(' ').filter(function (a) {
      return a;
    })));

    var cols = _this5.extractCol(_value2);

    _this5.state = {
      col: cols.length ? cols[0][0] : 'md',
      value: _value2,
      options: _value2
    };
    return _this5;
  }

  _createClass(ClassNamesEditor, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        var value = nextProps.value.split(' ').filter(function (a) {
          return a;
        });
        var options = this.state.options;
        var newOptions = value.filter(function (a) {
          return !options.includes(a);
        });
        this.setState({
          value: value,
          options: newOptions //[...options, ...newOptions]

        });
      }
    }
  }, {
    key: "extractCol",
    value: function extractCol(classNames) {
      var _this6 = this;

      return classNames.filter(function (a) {
        return a.startsWith('col-');
      }).map(function (a) {
        return a.split('-');
      }).filter(function (a) {
        return a.length === 3 && Number.isInteger(+a[2]) && _this6.colSizes.includes(a[1]);
      }).map(function (_ref18) {
        var _ref19 = _slicedToArray(_ref18, 3),
            a = _ref19[0],
            b = _ref19[1],
            c = _ref19[2];

        return [b, +c];
      });
    }
  }, {
    key: "renderMenu",
    value: function renderMenu() {
      var _this7 = this;

      return React.createElement(Menu, {
        onClick: function onClick(_ref20) {
          var key = _ref20.key;
          return _this7.setState({
            col: key
          });
        }
      }, this.colSizes.map(function (a) {
        return React.createElement(Menu.Item, {
          key: a
        }, "col-", a, "-");
      }));
    }
  }, {
    key: "sliderValue",
    value: function sliderValue() {
      var _this$state2 = this.state,
          value = _this$state2.value,
          col = _this$state2.col;
      return (this.extractCol(value).find(function (a) {
        return a[0] === col;
      }) || [0, 0])[1];
    }
  }, {
    key: "render",
    value: function render() {
      var _this8 = this;

      var _this$props3 = this.props,
          title = _this$props3.title,
          rest = _objectWithoutProperties(_this$props3, ["title"]);

      var _this$state3 = this.state,
          options = _this$state3.options,
          value = _this$state3.value,
          col = _this$state3.col;
      return React.createElement(FormItemTemplate, {
        title: title,
        remove: function remove() {
          return _this8.props.onChange(undefined);
        }
      }, React.createElement(Row, {
        type: "flex",
        align: "middle"
      }, React.createElement(Col, {
        xs: 4
      }, React.createElement(Dropdown, {
        overlay: this.renderMenu()
      }, React.createElement("a", null, col, " ", React.createElement(Icon, {
        type: "down"
      })))), React.createElement(Col, {
        xs: 20
      }, React.createElement(Slider, {
        min: 0,
        max: 12,
        value: this.sliderValue(),
        onChange: this.onSliderChange
      }))), React.createElement(Select, _extends({
        style: this.style,
        mode: "tags",
        tokenSeparators: [' ']
      }, rest, {
        value: value,
        onChange: function onChange(value) {
          return _this8.props.onChange(value.join(' '));
        },
        onBlur: this.onBlur
      }), options.map(function (a) {
        return React.createElement(Option, {
          key: a
        }, a);
      })));
    }
  }]);

  return ClassNamesEditor;
}(React.Component);

function classNames(_ref21) {
  var uiSchema = _ref21.node.uiSchema,
      update = _ref21.updateUiSchema;
  var key = 'classNames';
  var title = 'Class Names';
  var value = (uiSchema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(ClassNamesEditor, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update({
          classNames: value
        });
      }
    })];
  }
}

function placeholder(_ref22) {
  var _ref22$node = _ref22.node,
      schema = _ref22$node.schema,
      uiSchema = _ref22$node.uiSchema,
      update = _ref22.updateUiOptions;

  if (schema.type === 'object' || schema.type === 'array') {
    return [];
  }

  var key = 'placeholder';
  var title = 'Placeholder';
  var uiOptions = (uiSchema || {})['ui:options'];
  var value = (uiOptions || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(TimeThrottleInput, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value));
      }
    })];
  }
}

function help(_ref23) {
  var uiSchema = _ref23.node.uiSchema,
      update = _ref23.updateUiSchema;
  var key = 'ui:help';
  var title = 'Help';
  var value = (uiSchema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(TimeThrottleInput, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value));
      }
    })];
  }
}

function widget(_ref24) {
  var _ref24$node = _ref24.node,
      schema = _ref24$node.schema,
      uiSchema = _ref24$node.uiSchema,
      update = _ref24.updateUiSchema;
  var key = 'ui:widget';
  var title = 'Widget';
  var availableWidgets = widgets.filter(function (_ref25) {
    var _ref26 = _slicedToArray(_ref25, 1),
        f = _ref26[0];

    return f(schema || {}, uiSchema || {});
  });
  if (!availableWidgets.length) return [];
  var value = (uiSchema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(FormItemTemplate, {
      key: key,
      title: title,
      remove: function remove() {
        return update(_defineProperty({}, key, undefined));
      }
    }, React.createElement(Select, {
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value || null));
      },
      value: value,
      style: {
        width: '100%'
      },
      showSearch: true
    }, availableWidgets.map(function (_ref27) {
      var _ref28 = _slicedToArray(_ref27, 2),
          _ = _ref28[0],
          key = _ref28[1];

      return React.createElement(Option, {
        key: key
      }, key);
    })))];
  }
}

function pattern(_ref29) {
  var schema = _ref29.node.schema,
      update = _ref29.updateSchema;
  if (schema.type !== 'string') return [];
  var key = 'pattern';
  var title = 'Pattern';
  var value = (schema || {})[key];

  if (value === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, ''));
      }
    }, title)];
  } else {
    return [null, React.createElement(TimeThrottleInput, {
      key: key,
      title: title,
      value: value,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value || undefined));
      }
    })];
  }
}

function required(_ref30) {
  var schema = _ref30.node.schema,
      update = _ref30.updateSchema;
  var key = 'required';
  var title = 'Required';
  if (schema.type !== 'object') return [];

  if (!schema.required) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, []));
      }
    }, title)];
  }

  return [null, React.createElement(FormItemTemplate, {
    key: key,
    title: "Required",
    remove: function remove() {
      return update(_defineProperty({}, key, undefined));
    }
  }, React.createElement(Select, {
    mode: "multiple",
    style: {
      width: '100%'
    },
    onChange: function onChange(required) {
      return update({
        required: required
      });
    },
    value: schema.required
  }, Object.keys(schema.properties || {}).map(function (a) {
    return React.createElement(Option, {
      key: a
    }, a);
  })))];
}

var rangeMeta = function rangeMeta(match, key, title, minp, maxp) {
  return function (_ref31) {
    var schema = _ref31.node.schema,
        update = _ref31.updateSchema;
    if (!match(schema)) return [];

    if (schema[minp] === undefined && schema[maxp] === undefined) {
      return [React.createElement(Menu.Item, {
        key: key,
        onClick: function onClick() {
          return update(_defineProperty({}, minp, 0));
        }
      }, title)];
    }

    return [null, React.createElement(TimeThrottleRange, {
      key: key,
      title: title,
      value: [schema[minp], schema[maxp]],
      onChange: function onChange(value) {
        if (!value) {
          var _update20;

          update((_update20 = {}, _defineProperty(_update20, minp, undefined), _defineProperty(_update20, maxp, undefined), _update20));
        } else {
          var _update21;

          var _value3 = _slicedToArray(value, 2),
              min = _value3[0],
              max = _value3[1];

          update((_update21 = {}, _defineProperty(_update21, minp, min ? min : max === undefined ? 0 : undefined), _defineProperty(_update21, maxp, max), _update21));
        }
      }
    })];
  };
};

var length = rangeMeta(function (a) {
  return a.type === 'string';
}, 'length', 'Length', 'minLength', 'maxLength');
var range = rangeMeta(function (a) {
  return a.type === 'number' || a.type === 'integer';
}, 'range', 'Range', 'minimum', 'maximum');
var itemRange = rangeMeta(function (a) {
  return a.type === 'array';
}, 'itemRange', 'Item Range', 'minItems', 'maxItems');

function uniqueItems(_ref32) {
  var schema = _ref32.node.schema,
      update = _ref32.updateSchema;
  var key = 'uniqueItems';
  var title = 'Unique Items';
  if (schema.type !== 'array') return [];

  if (schema[key] === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, true));
      }
    }, title)];
  } else {
    return [null, React.createElement(List.Item, {
      actions: [React.createElement(Button, {
        onClick: function onClick() {
          return update(_defineProperty({}, key, undefined));
        },
        size: "small",
        type: "danger",
        shape: "circle",
        icon: "close"
      })]
    }, React.createElement(List.Item.Meta, {
      title: title
    }), React.createElement(Switch, {
      defaultChecked: true,
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value));
      }
    }))];
  }
}

var _map = [['enum', 'Enum'], ['enumNames', 'Enum Names']].map(function (_ref33) {
  var _ref34 = _slicedToArray(_ref33, 2),
      key = _ref34[0],
      title = _ref34[1];

  return function (_ref35) {
    var schema = _ref35.node.schema,
        update = _ref35.updateSchema;
    if (schema.type !== 'string') return [];

    if (schema[key] === undefined) {
      return [React.createElement(Menu.Item, {
        key: key,
        onClick: function onClick() {
          return update(_defineProperty({}, key, []));
        }
      }, title)];
    } else {
      return [null, React.createElement(FormItemTemplate, {
        key: key,
        title: title,
        remove: function remove() {
          return update(_defineProperty({}, key, undefined));
        }
      }, React.createElement(Select, {
        mode: "tags",
        style: {
          width: '100%'
        },
        onChange: function onChange(values) {
          return update(_defineProperty({}, key, values));
        },
        value: schema[key]
      }, schema[key].map(function (a) {
        return React.createElement(Select.Option, {
          key: a
        }, a);
      })))];
    }
  };
}),
    _map2 = _slicedToArray(_map, 2),
    enumKey = _map2[0],
    enumName = _map2[1];

var formatOptions = ['date-time', 'email', 'hostname', 'ipv4', 'ipv6', 'uri'];

function format(_ref36) {
  var schema = _ref36.node.schema,
      update = _ref36.updateSchema;
  var key = 'format';
  var title = 'Format';
  if (schema.type !== 'string') return [];

  if (schema[key] === undefined) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, []));
      }
    }, title)];
  } else {
    return [null, React.createElement(FormItemTemplate, {
      key: key,
      title: title,
      remove: function remove() {
        return update(_defineProperty({}, key, undefined));
      }
    }, React.createElement(Select, {
      style: {
        width: '100%'
      },
      onChange: function onChange(value) {
        return update(_defineProperty({}, key, value));
      },
      value: schema[key]
    }, formatOptions.map(function (a) {
      return React.createElement(Option, {
        key: a
      }, a);
    })))];
  }
}

var GroupsEditor =
/*#__PURE__*/
function (_React$Component3) {
  _inherits(GroupsEditor, _React$Component3);

  function GroupsEditor(props) {
    var _this9;

    _classCallCheck(this, GroupsEditor);

    _this9 = _possibleConstructorReturn(this, _getPrototypeOf(GroupsEditor).call(this, props)); // props.value

    _defineProperty(_assertThisInitialized(_this9), "style", {
      width: '100%'
    });

    _defineProperty(_assertThisInitialized(_this9), "freeProperties", function (total, groupName, groups) {
      var otherGroupProperties = Object.keys(groups).filter(function (g) {
        return g !== groupName;
      }).reduce(function (acc, cur) {
        acc = acc.concat(groups[cur].properties);
        return acc;
      }, []);
      return total.filter(function (p) {
        return otherGroupProperties.indexOf(p) < 0;
      });
    });

    var groupNames = Object.keys(props.value || {});
    _this9.state = {
      value: props.value,
      groupNames: groupNames,
      options: groupNames
    };
    return _this9;
  }

  _createClass(GroupsEditor, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        var value = nextProps.value;
        var options = this.state.options;
        var groupNames = Object.keys(value) || {};
        var newOptions = groupNames.filter(function (a) {
          return !options.includes(a);
        });
        this.setState({
          value: value,
          groupNames: groupNames,
          options: newOptions //[...options, ...newOptions]

        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this10 = this;

      var _this$props4 = this.props,
          title = _this$props4.title,
          properties = _this$props4.properties,
          rest = _objectWithoutProperties(_this$props4, ["title", "properties"]);

      var _this$state4 = this.state,
          options = _this$state4.options,
          value = _this$state4.value,
          groupNames = _this$state4.groupNames;
      return React.createElement(FormItemTemplate, {
        title: title,
        remove: function remove() {
          return _this10.props.onChange(undefined);
        }
      }, React.createElement(Select, _extends({
        style: this.style,
        mode: "tags",
        tokenSeparators: [" "]
      }, rest, {
        value: groupNames,
        onChange: function onChange(newGroupNames) {
          var newValue = newGroupNames.reduce(function (acc, cur) {
            acc[cur] = value[cur] || {
              properties: []
            };
            return acc;
          }, {});

          _this10.props.onChange(newValue);
        },
        onBlur: this.onBlur
      }), options.map(function (a) {
        return React.createElement(Option, {
          key: a
        }, a);
      })), groupNames.map(function (groupName) {
        return React.createElement(Select, {
          style: _this10.style,
          mode: "multiple",
          tokenSeparators: [" "],
          value: value[groupName].properties,
          onChange: function onChange(v) {
            var newValue = _objectSpread2({}, value);

            newValue[groupName].properties = v;

            _this10.props.onChange(newValue);
          } // onBlur={this.onBlur}

        }, _this10.freeProperties(properties, groupName, value).map(function (a) {
          return React.createElement(Option, {
            key: a
          }, a);
        }));
      }));
    }
  }]);

  return GroupsEditor;
}(React.Component);

function groups(_ref37) {
  var _ref37$node = _ref37.node,
      schema = _ref37$node.schema,
      uiSchema = _ref37$node.uiSchema,
      update = _ref37.updateUiSchema;
  var key = 'ui:groups';
  var title = 'Property Groups';
  if (schema.type !== 'object') return [];

  if (!uiSchema[key]) {
    return [React.createElement(Menu.Item, {
      key: key,
      onClick: function onClick() {
        return update(_defineProperty({}, key, []));
      }
    }, title)];
  }

  return [null, React.createElement(GroupsEditor, {
    key: key,
    properties: Object.keys(schema.properties) || [],
    title: title,
    value: uiSchema[key],
    onChange: function onChange(value) {
      return update(_defineProperty({}, key, value));
    }
  })];
}

var BasicEditor =
/*#__PURE__*/
function (_React$Component4) {
  _inherits(BasicEditor, _React$Component4);

  function BasicEditor() {
    _classCallCheck(this, BasicEditor);

    return _possibleConstructorReturn(this, _getPrototypeOf(BasicEditor).apply(this, arguments));
  }

  _createClass(BasicEditor, [{
    key: "name",
    value: function name() {
      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this11 = this;

      var l = [type, title, description, required, widget, classNames, help, placeholder, enumKey, enumName, pattern, length, range, itemRange, uniqueItems, format, groups].map(function (f) {
        return f(_this11.props);
      });
      var addable = l.map(function (a) {
        return a[0];
      }).filter(function (a) {
        return a;
      });
      var editable = l.map(function (a) {
        return a[1];
      }).filter(function (a) {
        return a;
      });

      if (addable.length) {
        editable.push(React.createElement(List.Item, {
          key: "addButton"
        }, React.createElement(Dropdown, {
          trigger: ['click'],
          overlay: React.createElement(Menu, null, addable)
        }, React.createElement(Button, {
          style: {
            width: '100%'
          },
          type: "primary",
          icon: "plus"
        }))));
      }

      return React.createElement(List, {
        itemLayout: "horizontal",
        dataSource: editable,
        renderItem: function renderItem(a) {
          return a;
        }
      });
    }
  }, {
    key: "_render",
    value: function _render() {
      return React.createElement("form", {
        className: "ant-form ant-form-horizontal"
      }, this.name(), React.createElement("fieldset", null, React.createElement("legend", null, "Schema"), this.title(), this.description()), React.createElement("fieldset", null, React.createElement("legend", null, "uiSchema"), this.widgets(), this.classNames(), this.help()));
    }
  }], [{
    key: "filter",
    value: function filter(node) {
      return node.schema;
    }
  }, {
    key: "key",
    get: function get() {
      return 'basic-editor';
    }
  }, {
    key: "name",
    get: function get() {
      return 'Basic';
    }
  }]);

  return BasicEditor;
}(React.Component);

export default BasicEditor;
export { FormItemTemplate };
