import React from 'react';
import { inherits as _inherits, createClass as _createClass, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, objectWithoutProperties as _objectWithoutProperties } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { Input } from 'antd';
import JsonEditor from '../JsonEditor.js';

var NodeJsonEditor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(NodeJsonEditor, _React$Component);

  _createClass(NodeJsonEditor, null, [{
    key: "filter",
    value: function filter(node) {
      return true;
    }
  }, {
    key: "key",
    get: function get() {
      return 'json-editor';
    }
  }, {
    key: "name",
    get: function get() {
      return 'Json';
    }
  }]);

  function NodeJsonEditor(props) {
    var _this;

    _classCallCheck(this, NodeJsonEditor);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NodeJsonEditor).call(this, props));
    var schema = props.schema,
        uiSchema = props.uiSchema;
    _this.state = {
      schemaJsonString: JSON.stringify(schema, null, 2),
      uiSchemaJsonString: JSON.stringify(schema, null, 2),
      schema: schema,
      uiSchema: uiSchema
    };
    return _this;
  }

  _createClass(NodeJsonEditor, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          node = _this$props.node,
          updateNode = _this$props.updateNode;
      var schema = node.schema,
          uiSchema = node.uiSchema;

      var properties = schema.properties,
          items = schema.items,
          additionalItems = schema.additionalItems,
          rschema = _objectWithoutProperties(schema, ["properties", "items", "additionalItems"]);

      return React.createElement("div", null, React.createElement(Input, {
        value: node.name,
        onChange: function onChange(e) {
          return updateNode({
            name: e.target.value
          });
        }
      }), React.createElement(JsonEditor, {
        value: rschema,
        onChange: function onChange(schema) {
          return updateNode({
            schema: schema
          });
        },
        autosize: true
      }), React.createElement(JsonEditor, {
        value: uiSchema,
        onChange: function onChange(uiSchema) {
          return updateNode({
            uiSchema: uiSchema
          });
        },
        autosize: true
      }));
    }
  }]);

  return NodeJsonEditor;
}(React.Component);

export default NodeJsonEditor;
