import React from 'react';
import { inherits as _inherits, createClass as _createClass, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, objectSpread2 as _objectSpread2, assertThisInitialized as _assertThisInitialized } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { Tabs } from 'antd';
import NodeJsonEditor from './JsonEditor.js';
import BasicEditor from './BasicEditor.js';

var _require = require('../core'),
    getNode = _require.getNode;

var TabPane = Tabs.TabPane;
var editorList = [BasicEditor, NodeJsonEditor];

var Editor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Editor);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Editor)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "updateUiOptions", function (uiOptionsUpdate) {
      var _this$props$node = _this.props.node,
          _this$props$node$uiSc = _this$props$node.uiSchema,
          uiSchema = _this$props$node$uiSc === void 0 ? {} : _this$props$node$uiSc,
          key = _this$props$node.key;
      var uiOptions = uiSchema['ui:options'] || {};

      var newUiOptions = _objectSpread2({}, uiOptions, {}, uiOptionsUpdate);

      for (var i in newUiOptions) {
        if (newUiOptions[i] !== undefined) {
          _this.props.updateNode(key, {
            uiSchema: _objectSpread2({}, uiSchema, {
              'ui:options': _objectSpread2({}, uiOptions, {}, newUiOptions)
            })
          });

          return;
        }
      }

      _this.props.updateNode(key, {
        uiSchema: _objectSpread2({}, uiSchema, {
          'ui:options': undefined
        })
      });
    });

    return _this;
  }

  _createClass(Editor, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          node = _this$props.node,
          _updateNode = _this$props.updateNode;
      if (!(node && node.schema)) return null;
      var filteredEditors = editorList.filter(function (a) {
        return a.filter(node);
      });
      return React.createElement(Tabs, {
        defaultActiveKey: filteredEditors[0].key,
        onChange: console.log
      }, filteredEditors.map(function (Editor) {
        return React.createElement(TabPane, {
          tab: Editor.name,
          key: Editor.key
        }, React.createElement("div", {
          style: {
            margin: '0px 16px'
          }
        }, React.createElement(Editor, {
          key: node.key,
          node: node,
          updateNode: function updateNode(nodeUpdate) {
            return _updateNode(node.key, nodeUpdate);
          },
          updateSchema: function updateSchema(schemaUpdate) {
            return _updateNode(node.key, {
              schema: _objectSpread2({}, node.schema, {}, schemaUpdate)
            });
          },
          updateUiSchema: function updateUiSchema(uiSchemaUpdate) {
            return _updateNode(node.key, {
              uiSchema: _objectSpread2({}, node.uiSchema, {}, uiSchemaUpdate)
            });
          },
          updateUiOptions: _this2.updateUiOptions
        })));
      }));
    }
  }]);

  return Editor;
}(React.Component);

var NodeEditor = connect(function (_ref) {
  var present = _ref.tree.present,
      activeNodeKey = _ref.activeNodeKey;
  return {
    node: activeNodeKey && getNode(present, activeNodeKey)
  };
}, function (dispatch) {
  return {
    updateNode: function updateNode(target, nodeUpdate) {
      return dispatch({
        type: 'TREE_UPDATE_NODE',
        payload: {
          target: target,
          nodeUpdate: nodeUpdate
        }
      });
    }
  };
})(Editor);

export default NodeEditor;
