import React, { Component } from 'react';
import { inherits as _inherits, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, createClass as _createClass } from '../_virtual/_rollupPluginBabelHelpers.js';
import { Input, Icon } from 'antd';

var InlineEditor =
/*#__PURE__*/
function (_Component) {
  _inherits(InlineEditor, _Component);

  function InlineEditor(props) {
    var _this;

    _classCallCheck(this, InlineEditor);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InlineEditor).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (e) {
      _this.setState({
        value: e.target.value
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onCompleteEditing", function () {
      _this.setState({
        editing: false
      });

      var newValue = _this.state.value.trim();

      if (newValue !== _this.props.value) {
        _this.props.onChange && _this.props.onChange(newValue);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onStartEditing", function (e) {
      e.stopPropagation();
      e.preventDefault();

      _this.setState({
        editing: true
      }, function () {
        return _this.input && _this.input.focus();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onCancelEditing", function () {
      _this.setState({
        editing: false,
        value: _this.props.value
      });
    });

    _this.state = {
      editing: false,
      value: _this.props.value
    };
    return _this;
  }

  _createClass(InlineEditor, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.value
      });
    }
  }, {
    key: "renderEditing",
    value: function renderEditing() {
      var _this2 = this;

      return React.createElement(Input, {
        ref: function ref(r) {
          return _this2.input = r;
        },
        value: this.state.value,
        onBlur: this.onCompleteEditing,
        onChange: this.onChange,
        onKeyUp: function onKeyUp(e) {
          e.preventDefault();
          e.stopPropagation();

          if (e.keyCode === 13) {
            _this2.onCompleteEditing();
          } else if (e.keyCode === 27) {
            _this2.onCancelEditing();
          }
        }
      });
    }
  }, {
    key: "renderView",
    value: function renderView() {
      return React.createElement("span", null, this.props.children, React.createElement(Icon, {
        type: "edit",
        onClick: this.onStartEditing
      }));
    }
  }, {
    key: "render",
    value: function render() {
      if (this.state.editing) {
        return this.renderEditing();
      } else {
        return this.renderView();
      }
    }
  }]);

  return InlineEditor;
}(Component);

export default InlineEditor;
