import React from 'react';
import { inherits as _inherits, createClass as _createClass, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, extends as _extends } from '../_virtual/_rollupPluginBabelHelpers.js';
import { Input, Alert } from 'antd';

var TextArea = Input.TextArea;

function shallowEqual(objA, objB) {
  if (objA === objB) {
    return true;
  }

  if (!objA || !objB) {
    return false;
  }

  var key; // Test for A's keys different from B.

  for (key in objA) {
    if (objA.hasOwnProperty(key) && (!objB.hasOwnProperty(key) || objA[key] !== objB[key])) {
      return false;
    }
  } // Test for B'a keys missing from A.


  for (key in objB) {
    if (objB.hasOwnProperty(key) && !objA.hasOwnProperty(key)) {
      return false;
    }
  }

  return true;
}

var JsonEditor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(JsonEditor, _React$Component);

  function JsonEditor(props) {
    var _this;

    _classCallCheck(this, JsonEditor);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(JsonEditor).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (e) {
      var value = e.target.value;

      try {
        var obj = value ? JSON.parse(value) : null;

        _this.setState({
          value: obj,
          string: value,
          error: null
        }, function () {
          return _this.props.onChange(obj);
        });
      } catch (error) {
        _this.setState({
          string: value,
          error: error
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClickPrettify", function () {
      var error = _this.state.error;

      if (!error) {
        _this.setState({
          string: JSON.stringify(_this.props.value, null, 2)
        });
      }
    });

    var _value = props.value;
    _this.state = {
      string: JSON.stringify(_value, null, 2),
      value: _value
    };
    return _this;
  }

  _createClass(JsonEditor, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!shallowEqual(nextProps.value, this.state.value)) {
        this.setState({
          value: nextProps.value,
          string: JSON.stringify(nextProps.value, null, 2),
          error: null
        });
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.string !== this.state.string;
    }
  }, {
    key: "renderErrorMessage",
    value: function renderErrorMessage() {
      var _this2 = this;

      var error = this.state.error;
      if (!error) return null;
      var errorMessage = error.toString();
      var message = React.createElement("a", {
        href: "#!",
        onClick: function onClick() {
          var matched = /position ([0-9]+)/.exec(errorMessage);
          var position = matched ? matched[1] : -1;
          var input = _this2.input.textAreaRef;
          input.selectionStart = position;
          input.selectionEnd = position;
          input.focus();
        }
      }, error.toString());
      return React.createElement(Alert, {
        message: message,
        type: "error",
        showIcon: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var string = this.state.string;
      return React.createElement("div", null, this.renderErrorMessage() || React.createElement(Alert, {
        message: React.createElement("a", {
          href: "#!",
          onClick: this.onClickPrettify
        }, "Prettify"),
        type: "success",
        showIcon: true
      }), React.createElement(TextArea, _extends({}, this.props, {
        ref: function ref(_ref) {
          return _this3.input = _ref;
        },
        value: string,
        onChange: this.onChange
      })));
    }
  }]);

  return JsonEditor;
}(React.Component);

export default JsonEditor;
