import React from 'react';
import { inherits as _inherits, createClass as _createClass, slicedToArray as _slicedToArray, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf } from '../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { Modal, Slider, Switch, Button, List } from 'antd';

var confirm = Modal.confirm;

var tipFormatter = function () {
  var flag = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  return function (number) {
    flag = !flag;
    return flag ? number : window.innerWidth - number;
  };
}();

var Settings =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Settings, _React$Component);

  function Settings() {
    _classCallCheck(this, Settings);

    return _possibleConstructorReturn(this, _getPrototypeOf(Settings).apply(this, arguments));
  }

  _createClass(Settings, [{
    key: "siderWidth",
    value: function siderWidth() {
      var _this = this;

      var _this$props$settings = this.props.settings,
          leftSiderWidth = _this$props$settings.leftSiderWidth,
          rightSiderWidth = _this$props$settings.rightSiderWidth;
      return {
        key: 'sider-width',
        title: 'Sider Width',
        description: React.createElement(Slider, {
          included: true,
          min: 0,
          max: window.innerWidth,
          tipFormatter: tipFormatter,
          range: true,
          value: [leftSiderWidth, window.innerWidth - rightSiderWidth],
          onChange: function onChange(_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                left = _ref2[0],
                right = _ref2[1];

            _this.props.updateSettings({
              leftSiderWidth: left > 200 ? left : 200,
              rightSiderWidth: window.innerWidth - right
            });
          }
        })
      };
    }
  }, {
    key: "formWidth",
    value: function formWidth() {
      var _this2 = this;

      return {
        key: 'form-item',
        title: 'Form Width',
        description: React.createElement(Slider, {
          min: 0,
          max: window.innerWidth,
          value: this.props.settings.formWidth,
          onChange: function onChange(value) {
            _this2.props.updateSettings({
              formWidth: value
            });
          }
        })
      };
    }
  }, {
    key: "inlineMode",
    value: function inlineMode() {
      var _this3 = this;

      return {
        key: 'inline-mode',
        title: 'Inline Mode',
        actions: [React.createElement(Switch, {
          onChange: function onChange(v) {
            return _this3.props.updateSettings({
              isInlineMode: v
            });
          },
          checked: this.props.settings.isInlineMode
        })]
      };
    }
  }, {
    key: "liveValidate",
    value: function liveValidate() {
      var _this4 = this;

      return {
        key: 'live-validate',
        title: 'Live Validate',
        actions: [React.createElement(Switch, {
          onChange: function onChange(v) {
            return _this4.props.updateSettings({
              isLiveValidate: v
            });
          },
          checked: this.props.settings.isLiveValidate
        })]
      };
    }
  }, {
    key: "menu",
    value: function menu() {
      var _this$props = this.props,
          setTree = _this$props.setTree,
          rootNode = _this$props.rootNode,
          setMenu = _this$props.setMenu,
          menu = _this$props.menu;
      return {
        key: 'menu',
        title: 'Menu',
        description: [React.createElement(Button, {
          key: "edit",
          onClick: function onClick() {
            return setTree(menu);
          }
        }, "Customize"), React.createElement(Button, {
          key: "set",
          onClick: function onClick() {
            return setMenu(rootNode);
          }
        }, "Apply Change")]
      };
    }
  }, {
    key: "reset",
    value: function reset() {
      return {
        key: 'reset',
        description: React.createElement(Button, {
          type: "danger",
          sytle: {
            width: '100%'
          },
          key: "edit",
          onClick: function onClick() {
            confirm({
              title: 'Reset Form Buiilder?',
              content: 'Removing persistent data from local storage.\n All settings and unsaved form will be lost.',
              okText: 'Continue',
              okType: 'danger',
              closable: true,
              maskClosable: true,
              onOk: function onOk() {
                window.localStorage.removeItem('persist:react-jsonschema-formbuilder');
                window.location.reload();
              }
            });
          }
        }, "Reset Form Builder")
      };
    }
  }, {
    key: "listItems",
    value: function listItems() {
      return [this.siderWidth(), this.formWidth(), this.inlineMode(), this.liveValidate(), this.menu(), this.reset()];
    }
  }, {
    key: "renderItem",
    value: function renderItem(a) {
      var Item = List.Item,
          Meta = List.Item.Meta;
      return React.createElement(Item, {
        key: a.key,
        actions: a.actions
      }, React.createElement(Meta, {
        title: a.title,
        description: a.description
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(List, {
        itemLayout: "horizontal",
        dataSource: this.listItems(),
        renderItem: this.renderItem
      });
    }
  }]);

  return Settings;
}(React.Component);

var Settings$1 = connect(function (_ref3) {
  var settings = _ref3.settings,
      _ref3$tree$present = _slicedToArray(_ref3.tree.present, 1),
      rootNode = _ref3$tree$present[0],
      menu = _ref3.menu;

  return {
    settings: settings,
    rootNode: rootNode,
    menu: menu
  };
}, function (dispatch) {
  return {
    updateSettings: function updateSettings(payload) {
      return dispatch({
        type: 'SETTINGS_UPDATE',
        payload: payload
      });
    },
    setTree: function setTree(_ref4) {
      var schema = _ref4.schema,
          uiSchema = _ref4.uiSchema;
      return dispatch({
        type: 'TREE_SET_TREE',
        payload: {
          name: 'menu',
          schema: schema,
          uiSchema: uiSchema
        }
      });
    },
    setMenu: function setMenu(_ref5) {
      var schema = _ref5.schema,
          uiSchema = _ref5.uiSchema;
      return dispatch({
        type: 'MENU_SET',
        payload: {
          schema: schema,
          uiSchema: uiSchema
        }
      });
    }
  };
})(Settings);

export default Settings$1;
