import React from 'react';
import { inherits as _inherits, createClass as _createClass, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, asyncToGenerator as _asyncToGenerator } from '../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { ActionTypes } from 'redux-undo';
import { Row, Tooltip, Button, Select, message } from 'antd';

function read(e) {
  var file = e.target.files[0];

  if (!file) {
    return;
  }

  var reader = new FileReader();
  var p = new Promise(function (resolve) {
    reader.onload = function (e) {
      var contents = e.target.result;
      resolve(contents);
    };
  });
  reader.readAsText(file);
  return p;
}

var buttonStyle = {
  marginLeft: 8
};

var Toolbar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Toolbar, _React$Component);

  function Toolbar(props) {
    var _this;

    _classCallCheck(this, Toolbar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Toolbar).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "save", function () {
      var _this$props$tree$pres = _this.props.tree.present[0],
          name = _this$props$tree$pres.name,
          schema = _this$props$tree$pres.schema,
          uiSchema = _this$props$tree$pres.uiSchema; // write(name, { name, schema, uiSchema });

      var onSave = _this.props.onSave;

      if (onSave) {
        onSave({
          schema: schema,
          uiSchema: uiSchema
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "open",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(e) {
        var s, _JSON$parse, name, schema, uiSchema;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return read(e);

              case 2:
                s = _context.sent;

                try {
                  _JSON$parse = JSON.parse(s), name = _JSON$parse.name, schema = _JSON$parse.schema, uiSchema = _JSON$parse.uiSchema;

                  _this.props.setTree({
                    name: name,
                    schema: schema,
                    uiSchema: uiSchema
                  });
                } catch (e) {
                  message.error('Invalid json file!');
                }

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _this.state = {};
    return _this;
  }

  _createClass(Toolbar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          tree = _this$props.tree,
          undo = _this$props.undo,
          redo = _this$props.redo,
          settings = _this$props.settings,
          updateSettings = _this$props.updateSettings,
          newForm = _this$props.newForm,
          onOpen = _this$props.onOpen;
      var past = tree.past,
          future = tree.future;
      return React.createElement(Row, null, React.createElement("input", {
        ref: function ref(_ref2) {
          return _this2.loadFile = _ref2;
        },
        type: "file",
        accept: "application/json",
        onChange: this.open,
        hidden: true
      }), React.createElement(Tooltip, {
        title: "Open"
      }, React.createElement(Button, {
        style: buttonStyle,
        onClick: onOpen,
        icon: "folder-open"
      })), React.createElement(Tooltip, {
        title: "Save"
      }, React.createElement(Button, {
        style: buttonStyle,
        onClick: this.save,
        icon: "save"
      })), React.createElement(Tooltip, {
        title: "Undo"
      }, React.createElement(Button, {
        style: buttonStyle,
        onClick: undo,
        disabled: !past.length,
        icon: "left"
      })), React.createElement(Tooltip, {
        title: "Redo"
      }, React.createElement(Button, {
        style: buttonStyle,
        onClick: redo,
        disabled: !future.length,
        icon: "right"
      })), React.createElement(Select, {
        mode: "multiple",
        style: {
          width: 290,
          marginLeft: 12
        },
        value: settings.subViews,
        onChange: updateSettings,
        placeholder: "Select sub views..."
      }, React.createElement(Select.Option, {
        key: "schema"
      }, "Schema"), React.createElement(Select.Option, {
        key: "uiSchema"
      }, "Ui Schema"), React.createElement(Select.Option, {
        key: "formData"
      }, "Data")));
    }
  }]);

  return Toolbar;
}(React.Component);

var Toolbar$1 = connect(function (_ref3) {
  var tree = _ref3.tree,
      settings = _ref3.settings;
  return {
    tree: tree,
    settings: settings
  };
}, function (dispatch) {
  return {
    newForm: function newForm() {
      return dispatch({
        type: 'TREE_CLEAR'
      });
    },
    setTree: function setTree(payload) {
      return dispatch({
        type: 'TREE_SET_TREE',
        payload: payload
      });
    },
    undo: function undo() {
      return dispatch({
        type: ActionTypes.UNDO
      });
    },
    redo: function redo() {
      return dispatch({
        type: ActionTypes.REDO
      });
    },
    updateSettings: function updateSettings(subViews) {
      return dispatch({
        type: 'SETTINGS_UPDATE',
        payload: {
          subViews: subViews
        }
      });
    }
  };
})(Toolbar);

export default Toolbar$1;
