import React from 'react';
import { inherits as _inherits, createClass as _createClass, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, objectSpread2 as _objectSpread2, assertThisInitialized as _assertThisInitialized } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { Menu } from 'antd';

var SubMenu = Menu.SubMenu,
    Item = Menu.Item;

function nameGen(name, occupied) {
  var n = 1;
  var newName = name;

  while (occupied && occupied.includes(newName)) {
    newName = name + '_' + n;
    n += 1;
  }

  return newName;
}

var AddItemMenu =
/*#__PURE__*/
function (_React$Component) {
  _inherits(AddItemMenu, _React$Component);

  function AddItemMenu() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, AddItemMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(AddItemMenu)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onAddNode", function (node2add) {
      var addNode = _this.props.addNode;
      var name = nameGen(node2add.name, _this.props.node.children.map(function (a) {
        return a.name;
      }));
      addNode(_objectSpread2({}, node2add, {
        name: name
      }));
    });

    return _this;
  }

  _createClass(AddItemMenu, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          menuTree = _this$props.menu.children,
          menuOpenKeys = _this$props.menuOpenKeys,
          menuOpenChange = _this$props.menuOpenChange;
      console.log(menuOpenKeys);
      return React.createElement(Menu, {
        mode: "inline",
        theme: "dark",
        openKeys: menuOpenKeys,
        onOpenChange: menuOpenChange
      }, menuTree.map(function (a) {
        return a.schema && a.schema.type === 'object' && a.children && a.children.length ? React.createElement(SubMenu, {
          key: a.key,
          title: a.schema.title || a.name
        }, a.children.map(function (b) {
          return React.createElement(Item, {
            key: b.key,
            onClick: function onClick() {
              return _this2.onAddNode(b);
            }
          }, b.schema.title || b.name);
        })) : React.createElement(Item, {
          key: a.key,
          onClick: function onClick() {
            return _this2.onAddNode(a);
          }
        }, a.schema.title || a.name);
      }));
    }
  }]);

  return AddItemMenu;
}(React.Component);

var AddItemMenu$1 = connect(function (_ref) {
  var menu = _ref.menu,
      menuOpenKeys = _ref.menuOpenKeys;
  return {
    menu: menu,
    menuOpenKeys: menuOpenKeys
  };
}, function (dispatch, _ref2) {
  var node = _ref2.node;
  return {
    addNode: function addNode(node2add) {
      return dispatch({
        type: 'TREE_ADD_NODE',
        payload: {
          targetNodeKey: node.key,
          position: 0,
          node2add: node2add
        }
      });
    },
    menuOpenChange: function menuOpenChange(keys) {
      return dispatch({
        type: 'MENU_OPEN_KEYS_SET',
        payload: keys
      });
    }
  };
})(AddItemMenu);

export default AddItemMenu$1;
