import React, { Component } from 'react';
import { inherits as _inherits, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, toConsumableArray as _toConsumableArray, createClass as _createClass, slicedToArray as _slicedToArray } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { Tree as Tree$1, Input } from 'antd';
import TreeNodeTitle from './TreeNodeTitle.js';

var TreeNode = Tree$1.TreeNode;
var Search = Input.Search;

var Demo =
/*#__PURE__*/
function (_Component) {
  _inherits(Demo, _Component);

  function Demo(props) {
    var _this;

    _classCallCheck(this, Demo);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Demo).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onDragEnter", function (info) {// console.log(info);
      // expandedKeys 需要受控时设置
      // this.setState({
      //   expandedKeys: info.expandedKeys,
      // });
    });

    _defineProperty(_assertThisInitialized(_this), "onDrop", function (info) {
      // console.log(info);
      var dropKey = info.node.props.eventKey;
      var dragKey = info.dragNode.props.eventKey;
      var dropPos = info.node.props.pos.split('-');
      var dropPosition = info.dropPosition - Number(dropPos[dropPos.length - 1]); // const dragNodesKeys = info.dragNodesKeys;

      _this.props.moveNode(dragKey, dropKey, dropPosition);
    });

    _defineProperty(_assertThisInitialized(_this), "onExpand", function (expandedKeys) {
      _this.setState({
        expandedKeys: expandedKeys
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (e) {
      var expandedKeys = _this.state.expandedKeys;
      var searchValue = e.target.value.trim().toLowerCase();

      if (!searchValue) {
        _this.setState({
          searchValue: searchValue,
          searchExpanded: []
        });

        return;
      }

      var newSearchExpanded = [];

      var loop = function loop(data) {
        if (!data) return;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = data[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var item = _step.value;

            if (item.name.toLowerCase().includes(searchValue)) {
              var parents = item.key.split('.');
              var n = parents.length;

              for (var i = 1; i < n; i++) {
                if (!(expandedKeys.includes(parents[i - 1]) || newSearchExpanded.includes(parents[i - 1]))) {
                  newSearchExpanded.push(parents[i - 1]);
                }

                parents[i] = parents[i - 1] + '.' + parents[i];
              }
            }

            loop(item.children);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      };

      loop(_this.props.tree);

      _this.setState({
        searchValue: searchValue,
        searchExpanded: newSearchExpanded
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function () {
      _this.setState({
        expandedKeys: [].concat(_toConsumableArray(_this.state.expandedKeys), _toConsumableArray(_this.state.searchExpanded)),
        searchExpanded: []
      });
    });

    _this.state = {
      expandedKeys: ['root'],
      searchValue: '',
      searchExpanded: []
    };
    return _this;
  }

  _createClass(Demo, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.activeNodeKey && nextProps.activeNodeKey !== this.props.activeNodeKey) {
        var path = nextProps.activeNodeKey.split('.');

        var expandedKeys = _toConsumableArray(this.state.expandedKeys);

        var n = path.length;

        for (var i = 1; i < n; i++) {
          path[i] = path[i - 1] + '.' + path[i];

          if (!expandedKeys.includes(path[i - 1])) {
            expandedKeys.push(path[i - 1]);
          }
        }

        this.setState({
          expandedKeys: expandedKeys
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          tree = _this$props.tree,
          setActiveNode = _this$props.setActiveNode,
          activeNodeKey = _this$props.activeNodeKey;
      var _this$state = this.state,
          searchValue = _this$state.searchValue,
          expandedKeys = _this$state.expandedKeys,
          searchExpanded = _this$state.searchExpanded;

      var loop = function loop(data) {
        return data.map(function (item) {
          if (item.children && item.children.length) {
            return React.createElement(TreeNode, {
              key: item.key,
              title: React.createElement(TreeNodeTitle, {
                node: item,
                searchValue: searchValue
              }),
              isLeaf: item.isLeaf
            }, loop(item.children));
          }

          return React.createElement(TreeNode, {
            key: item.key,
            title: React.createElement(TreeNodeTitle, {
              node: item,
              searchValue: searchValue
            }),
            isLeaf: item.isLeaf
          });
        });
      };

      var children = loop(tree);
      return React.createElement("div", null, React.createElement(Search, {
        placeholder: "Search",
        onChange: this.onChange,
        onBlur: this.onBlur
      }), React.createElement(Tree$1, {
        className: "form-builder-draggable-tree",
        expandedKeys: searchExpanded.length ? [].concat(_toConsumableArray(expandedKeys), _toConsumableArray(searchExpanded)) : expandedKeys,
        selectedKeys: [activeNodeKey],
        draggable: true,
        onDragEnter: this.onDragEnter,
        onDrop: this.onDrop,
        onExpand: this.onExpand,
        onSelect: function onSelect(_ref) {
          var _ref2 = _slicedToArray(_ref, 1),
              selected = _ref2[0];

          return setActiveNode(selected);
        }
      }, children));
    }
  }]);

  return Demo;
}(Component);

var Tree = connect(function (_ref3) {
  var present = _ref3.tree.present,
      activeNodeKey = _ref3.activeNodeKey;
  return {
    tree: present,
    activeNodeKey: activeNodeKey
  };
}, function (dispatch) {
  return {
    moveNode: function moveNode(source, target, position) {
      return dispatch({
        type: 'TREE_MOVE_NODE',
        payload: {
          source: source,
          target: target,
          position: position
        }
      });
    },
    removeNode: function removeNode(target) {
      return dispatch({
        type: 'TREE_REMOVE_NODE',
        payload: target
      });
    },
    setActiveNode: function setActiveNode(selectedKey) {
      return dispatch({
        type: 'ACTIVE_NODE_KEY_SET',
        payload: selectedKey
      });
    },
    updateNodeTitle: function updateNodeTitle(target, name) {
      return dispatch({
        type: 'TREE_UPDATE_NODE',
        payload: {
          target: target,
          node: {
            name: name
          },
          updateMode: 1
        }
      });
    }
  };
})(Demo);

export default Tree;
