import React, { PureComponent } from 'react';
import { inherits as _inherits, classCallCheck as _classCallCheck, possibleConstructorReturn as _possibleConstructorReturn, getPrototypeOf as _getPrototypeOf, createClass as _createClass } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import { Dropdown, Icon, Popconfirm } from 'antd';
import InlineEditor from '../InlineEditor.js';
import AddItemMenu from './Menu.js';

var TreeNodeTitle =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(TreeNodeTitle, _PureComponent);

  function TreeNodeTitle() {
    _classCallCheck(this, TreeNodeTitle);

    return _possibleConstructorReturn(this, _getPrototypeOf(TreeNodeTitle).apply(this, arguments));
  }

  _createClass(TreeNodeTitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          node = _this$props.node,
          removeNode = _this$props.removeNode,
          updateNodeName = _this$props.updateNodeName,
          searchValue = _this$props.searchValue;
      var name = node.name,
          key = node.key;
      var isLeaf = node.isLeaf;
      var isRoot = node.name === node.key;
      var isArray = node.schema.type === 'array';
      var indexBefore = node.name.toLowerCase().indexOf(searchValue);
      var indexAfter = indexBefore + searchValue.length;
      return React.createElement("span", {
        style: {
          width: '100%',
          display: 'block'
        }
      }, searchValue && indexBefore >= 0 ? React.createElement(InlineEditor, {
        value: node.name,
        onChange: function onChange(name) {
          return updateNodeName(key, name);
        }
      }, name.slice(0, indexBefore), React.createElement("span", {
        style: {
          color: '#f50'
        }
      }, name.slice(indexBefore, indexAfter)), name.slice(indexAfter)) : React.createElement(InlineEditor, {
        value: node.name,
        onChange: function onChange(name) {
          return updateNodeName(key, name);
        }
      }, name), React.createElement("span", {
        className: "pull-right"
      }, !(isLeaf || isArray) ? React.createElement("span", {
        className: "form-builder-add-item-menu",
        onClick: function onClick(e) {
          return e.stopPropagation();
        }
      }, React.createElement(Dropdown, {
        placement: "bottomLeft",
        trigger: ['click'],
        overlay: React.createElement(AddItemMenu, {
          node: node
        })
      }, React.createElement(Icon, {
        type: "plus-circle-o"
      }))) : null, !isRoot ? React.createElement("span", {
        className: "tree-node-delete",
        onClick: function onClick(e) {
          return e.stopPropagation();
        }
      }, React.createElement(Popconfirm, {
        placement: "rightTop",
        title: "Delete \"".concat(key, "\"?"),
        onConfirm: function onConfirm() {
          return removeNode(key);
        },
        okText: "Yes",
        cancelText: "No"
      }, React.createElement(Icon, {
        type: "close-circle"
      }))) : null));
    }
  }]);

  return TreeNodeTitle;
}(PureComponent);

var TreeNodeTitle$1 = connect(null, function (dispatch) {
  return {
    removeNode: function removeNode(key) {
      return dispatch({
        type: 'TREE_REMOVE_NODE',
        payload: key
      });
    },
    updateNodeName: function updateNodeName(key, name) {
      return dispatch({
        type: 'TREE_UPDATE_NODE',
        payload: {
          target: key,
          nodeUpdate: {
            name: name
          }
        }
      });
    }
  };
})(TreeNodeTitle);

export default TreeNodeTitle$1;
