import React, { useMemo } from 'react';
import { List, Button } from 'antd';

var FormList = function FormList(_ref) {
  var data = _ref.data,
      onSelect = _ref.onSelect;
  var items = useMemo(function () {
    return data.map(function (d) {
      return React.createElement(List.Item, {
        key: d.id,
        onClick: function onClick() {
          return onSelect(d);
        }
      }, d.name);
    });
  }, [data]);
  return React.createElement("div", null, React.createElement("div", {
    style: {
      position: 'relative',
      right: 0
    }
  }, React.createElement(Button, {
    onClick: function onClick() {
      return onSelect(null);
    },
    type: "primary",
    icon: "plus"
  })), React.createElement(List, {
    bordered: true
  }, items));
};

export default FormList;
