import { createStore } from 'redux';
import reducer from './reducers.js';
import { persistReducer, persistStore } from 'redux-persist';
import { schema, uiSchema } from './config.js';
import storage from '../node_modules/redux-persist/lib/storage/index.js';
import hardSet from '../node_modules/redux-persist/lib/stateReconciler/hardSet.js';

var persistConfig = {
  key: 'react-jsonschema-formbuilder',
  storage: storage,
  stateReconciler: hardSet,
  throttle: 15
};

var _require = require('./core'),
    schema2tree = _require.schema2tree; // var form = {
//   schema: {
//     title: 'A registration form',
//     description: 'A simple form example.',
//     type: 'object',
//     required: ['firstName', 'lastName'],
//     properties: {
//       firstName: {
//         type: 'string',
//         title: 'First name',
//       },
//       lastName: {
//         type: 'string',
//         title: 'Last name',
//       },
//       age: {
//         type: 'integer',
//         title: 'Age',
//         description: '(earthian year)',
//       },
//       bio: {
//         type: 'string',
//         title: 'Bio',
//       },
//       password: {
//         type: 'string',
//         title: 'Password',
//         minLength: 3,
//       },
//       telephone: {
//         type: 'string',
//         title: 'Telephone',
//         minLength: 10,
//       },
//     },
//   },
//   uiSchema: {
//     firstName: {
//       classNames: '',
//       'ui:emptyValue': '',
//     },
//     age: {
//       'ui:widget': 'updown',
//     },
//     bio: {
//       'ui:widget': 'textarea',
//     },
//     password: {
//       'ui:widget': 'password',
//       'ui:help': 'Hint: Make it strong!',
//     },
//     date: {
//       'ui:widget': 'alt-datetime',
//     },
//     telephone: {
//       'ui:options': {
//         inputType: 'tel',
//       },
//     },
//   },
// };


var form = {
  schema: schema,
  uiSchema: uiSchema
};
var initTree = schema2tree('root', form.schema, form.uiSchema);
var persistedReducer = persistReducer(persistConfig, reducer);
var store = createStore(persistedReducer, {
  tree: {
    past: [],
    present: initTree,
    future: []
  }
});
var persistor = persistStore(store);

export { persistor, store };
