import React from 'react';
import { slicedToArray as _slicedToArray } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { connect } from 'react-redux';
import JsonEditor from '../JsonEditor.js';

var SchemaView = connect(function (_ref) {
  var _ref$tree$present = _slicedToArray(_ref.tree.present, 1),
      schema = _ref$tree$present[0].schema;

  return {
    schema: schema
  };
}, function (dispatch) {
  return {
    setTree: function setTree(schema) {
      return dispatch({
        type: 'TREE_SET_TREE',
        payload: {
          schema: schema
        }
      });
    }
  };
})(function (_ref2) {
  var schema = _ref2.schema,
      setTree = _ref2.setTree;
  return React.createElement(JsonEditor, {
    value: schema,
    onChange: function onChange(value) {
      return setTree(value);
    },
    autosize: true
  });
});

export default SchemaView;
