import typescript from 'rollup-plugin-typescript2';
import pkg from './package.json';
// import less from 'rollup-plugin-less';
import path from 'path';
import babel from 'rollup-plugin-babel';
import commonjs from 'rollup-plugin-commonjs';
import css from 'rollup-plugin-css-porter';
import lessModules from 'rollup-plugin-less-modules';

const resolve = d => path.resolve(__dirname, d);

export default {
  input: ["src/index.js",], // our source file
  output: [
    {
      dir: "lib/",
      //  file: 'lib/index.js',
      format: "es"
    }
  ],
  preserveModules: true,
  external: [...Object.keys(pkg.dependencies || {}), 'antd'],
  plugins: [
    typescript({
      tsconfig: resolve("tsconfig.json"),
      tsconfigOverride: {
        compilerOptions: {
          declaration: true,
          // declarationMap: true,
        }
      }
    }),
    babel({
      exclude: "node_modules/**",
      extensions: [".js", ".jsx", ".ts", ".tsx"],
    }),
    css(),
    lessModules(),
    commonjs(),
  ]
};