import React, { useMemo } from 'react';
import { List, Button } from 'antd';

const FormList = ({ data, onSelect }) => {

  const items = useMemo(() => {
    return data.map(d => (
      <List.Item key={d.id} onClick={() => onSelect(d)}>{d.name}</List.Item>
    ));
  } ,[data]);

  return (
    <div>
      <div style={{ position: 'relative', right: 0 }}><Button onClick={() => onSelect(null)} type="primary" icon="plus" /></div>
      <List bordered>
        {items}
      </List>
    </div>
  );
}

export default FormList;
