import React from 'react';
import { connect } from 'react-redux';
import Form from '@ofm/ofm-jsonschema-form';

class FormView extends React.Component {
  render() {
    if (!this.props.schema) {
      return null;
    }
    const { schema, uiSchema, formData, setFormData, liveValidate } = this.props;
    console.log('uiSchema: ', uiSchema);
    return (
      <Form
        key={Math.random()}
        schema={schema}
        uiSchema={uiSchema}
        formData={formData}
        onChange={setFormData}
      />
    );
  }
}

export default connect(
  ({
    tree: {
      present: [{ name, schema, uiSchema }],
    },
    formData,
    settings: { isLiveValidate },
  }) => ({
    name,
    schema,
    uiSchema,
    formData,
    liveValidate: isLiveValidate,
  }),
  (dispatch) => ({
    setFormData: ({ formData }) =>
      dispatch({
        type: 'FORM_DATA_SET',
        payload: formData,
      }),
  })
)(FormView);
