const path = require('path');
const HtmlWebPackPlugin = require('html-webpack-plugin');

module.exports = {
  mode: "development",
  entry: "./builder/index.js",
  output: {
    filename: '[name].js',
    path: path.resolve(__dirname, "dist")
  },
  resolve: {
    extensions: ['.js', '.jsx', '.ts', '.tsx'],
  },
  devServer: {
    contentBase: path.join(__dirname, 'dist'),
    compress: true,
    port: 9000
  },
  module: {
    rules: [
      {
        test: /\.css|less$/,
        use: ["style-loader", "css-loader", "less-loader"]
      },
      {
        test: /\.ts(x?)|js(x?)$/,
        exclude: /node_modules/,
        use: [{ loader: "ts-loader" }]
      },
      {
        test: /\.html$/,
        use: [
          {
            loader: "html-loader"
          }
        ]
      }
    ]
  },
  devtool : 'source-maps',
  plugins: [
    new HtmlWebPackPlugin({
      template: "./src/demo/index.html",
    })
  ]
};